# Nick completer by Hugo Haas (c) 2001
# Original idea by DC-itsme!carabalo@hilbert.geom.umn.edu

//^bind ^t parse_command complete_nick

alias getnicklist {
  @ indexmatch = [$match($0* $onchannel(*))] - 1
  if (indexmatch != -1) {
    ^assign function_return $midw($indexmatch $#onchannel(*) $onchannel(*)) $leftw($indexmatch $onchannel(*))
  }
  ^assign -indexmatch
}

alias complete_nick {
  if (curpos() != 0) {
    parsekey delete_to_previous_space
    if ([$U]==[])
    {
     parsekey backward_character
     parsekey delete_to_previous_space
    } 
    ^assign anc $U
    if ([$U] == [-])
    {
     parsekey backward_character
     parsekey delete_to_previous_space
     parsekey yank_from_cutbuffer
     parsekey forward_character
     #echo done
    } 
    type $anc
    parsekey forward_character
    #echo $anc $U
    ^assign nicklist $getnicklist($U)
  } {
    ^assign nicklist $onchannel(*)
  }
  if ( [$nicklist] != [] ) {
    ^assign completenick $leftw(1 $nicklist)
    if ([$completenick] == [$U]) {
      if ([$#nicklist] != 1) {
        parsekey backward_character
	parsekey delete_character
        parsekey delete_to_previous_space
	parsekey backward_character
	parsekey delete_character
	parsekey delete_to_previous_space
	type $sar(g/^/\\^/$leftw(1 $remw($completenick $nicklist)) - )
      }
    } {
      parsekey delete_to_previous_space
      type $sar(g/^/\\^/$completenick - ) 
    }
    ^assign -completenick
  }
  ^assign -nicklist
}

onload cecho3 Nick Completer module loaded
